<?php 

	/**
	* Team Availability Component Backend
	* @package TeamAvailabilityComponent
	* @copyright 2004 Tom Winterhalder
	* @license http://www.gnu.org/copyleft/gpl.html. GNU Public License
	* @version $Revision: 1.3 $
	* @author Tom Winterhalder <tom@winterhalder.ch>
	*/
	/*
	* Description
	* ===========
	* The admin.teac.php file controls the logic of the administrator backend.
	* It is responsible for all the functions configuring the team availability
	* component. 
	*/
	
	//ensure this file is being included by a parent file
	defined('_VALID_MOS') or die ('Direct Access to this location is not allowed.');
	
	global $_CONFIG;
	
	if ($_CONFIG->SITEPATH == "") {
		$_CONFIG->SITEPATH=$mosConfig_absolute_path;
		$_CONFIG->SITEURL = $mosConfig_live_site;
	}
	//error_reporting(E_ALL);

	require_once( $mainframe->getPath( 'admin_html' ) );
	require_once( $mainframe->getPath( 'class' ) );

	//Get language file
	if (file_exists($_CONFIG->SITEPATH.'/administrator/components/com_teac/language/'.$mosConfig_lang.'.php')) {
	  include($_CONFIG->SITEPATH.'/administrator/components/com_teac/language/'.$mosConfig_lang.'.php');
	} else {
	  include($_CONFIG->SITEPATH.'/administrator/components/com_teac/language/english.php');
	}
	
	//include configuration file
	if (file_exists($_CONFIG->SITEPATH.'/administrator/components/com_teac/teac_config.php')) {
	  include($_CONFIG->SITEPATH.'/administrator/components/com_teac/teac_config.php');
	} else {
	  die ("Error finding configuration file (".$_CONFIG->SITEPATH."/administrator/components/com_teac/teac_config.php)");
	}
	
	$cid = mosGetParam( $_POST, 'cid', array(0) );
	if (!is_array( $cid )) {
	   $cid = array(0);
	}
	
	// ensure user has access to this function
	if (!($acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'all' )
		| $acl->acl_check( 'administration', 'edit', 'users', $my->usertype, 'components', 'com_newsfeeds' ))) {
		mosRedirect( 'index2.php', _NOT_AUTH );
	}
	
	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit );
	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );

	// ***************************
	// actions and tasks selection
	// ***************************
	//echo "act: ".$act ." task: " .$task;
	switch ($task) {
		case 'member':
			listMember($option);
			break;
		case 'newTeam' :
			$cid = '';
		case 'editTeam':
			editTeam($option, $cid);
			break;
		case 'saveTeam':
			saveTeam($option);
			break;
		case 'deleteTeam' :
			delTeam($option, $cid);
			break;
		case 'publishTeam':
			publishTeam($option, '1', $cid);
			break;
		case 'unpublishTeam':
			publishTeam($option, '0', $cid);
			break;
		case 'showTeam':
			listTeam($option);
			break;
		case 'newMem':
			$cid='';
		case 'editMem':
			editMem($option, $cid);
			break;
		case 'saveMem':
			saveMem($option);
			break;
		case 'deleteMem' :
			delMem($option, $cid);
			break;
		case 'publishMem':
			publishMem($option, '1', $cid);
			break;
		case 'unpublishMem':
			publishMem($option, '0', $cid);
			break;
		case 'showMember':
			listMember($option);
			break;
		case "newAbs" :
			$cid[0] = '';
		case "editAbs" :
			editAbs( $option, $cid );
			break;
		case "saveAbs" :
			saveAbs($option);
			break;
		case "deleteAbs" :
			delAbs($option, $cid);
			break;
		case "publishAbs" :
			publishAbs($option, '1', $cid);
			break;
		case "unpublishAbs" :
			publishAbs($option, '0', $cid);
			break;
		case 'showAbsence':
			listAbsence($option);
			break;
		case 'editConfig':
			modifyConfig($option);
			break;
		case 'saveConfig':
			saveConfig($option);
			break;
	   	case "editCss":
	     	editCss($option);
    	 	break;
   		case "saveCss":
     		saveCss ($file,$csscontent, $option);
     		break;
		case 'cpanel':
		default:
			$version=$teacConfig['version'];
			HTML_twTeac::controlPanel($version, $task);
			break;	
	} // end switch
	// *******************
	// CSS control section
	// *******************
	function editCss ($option) {
		global $teacConfig, $_CONFIG;
		
		if ($_CONFIG->SITEPATH == "") {
			$_CONFIG->SITEPATH=$mosConfig_absolute_path;
			$_CONFIG->SITEURL = $mosConfig_live_site;
		}	
	   	$cssfile = $_CONFIG->SITEPATH."/components/com_teac/css/teac.css.php";
      	$file = "../components/com_teac/css/teac.css";
      	$permission = is_writable($file);
      	if (!$permission) {
			
      		echo "<center><h1><font color=red>"._TEAC_LANG_CSS_WRITE ."</FONT></h1><BR></center>";
			echo "<b>"._TEAC_LANG_CSS_FILE." $cssfile<br>";
			echo _TEAC_LANG_CHMOD_766."</b></center><br><br>";
      	}
      	HTML_twTEAC::editCss($file,$option);
  	} // end function editCss
	function saveCss($file,$csscontent, $option) {
//   		echo "Saving css file should be here...file=$file";
  		if (!is_writable($file)) {
     		mosRedirect("index2.php?option=$option&task=editCss", _TEAC_LANG_ERR_CSS_WRITE.":" .$file );
   		}
    	echo "<script>alert("._TEAC_LANG_CSS_SAVED.")</script>";
    	echo "<script>document.location.href='index2.php?option=com_teac&task=editCss'</script>\n";
    	if ($fp = fopen( $file, "w")) {
      		fputs($fp,stripslashes($csscontent));
       		fclose($fp);
       		mosRedirect( "index2.php?option=$option&task=editCss", _TEAC_LANG_CSS_SAVED );
    	} else {
       		mosRedirect( "index2.php?option=$option", _TEAC_LANG_ERR_CSS_OPEN );
    	}
	} // end function saveCss
	// *************************
	// Parameter control section
	// *************************
	function modifyConfig($option) {
		global $database, $mosConfig_lang, $mosConfig_absolute_path, $mosConfig_admin_template, $mosConfig_live_site;
		global $_CONFIG;
	
		if ($_CONFIG->SITEPATH == "") {
			$_CONFIG->SITEPATH=$mosConfig_absolute_path;
			$_CONFIG->SITEURL = $mosConfig_live_site;
		}	

	   	$configfile = $_CONFIG->SITEPATH."/administrator/components/com_teac/teac_config.php";
//   	   	@chmod ($configfile, 0766);
   		$permission = is_writable($configfile);
   		if (!$permission) {
	    	echo "<center><h1><font color=red>"._TEAC_LANG_ERR_CONF_WRITE."</FONT></h1><BR>";
      		echo "<B>"._TEAC_LANG_CONFFILE." $configfile</b><BR>";
      		echo "<B>"._TEAC_LANG_CHMOD_766."</B></center><BR><BR>";
   		}
	  	include( $configfile );
		// make a standard yes/no list
      	$yesno = array();
      	$yesno[] = mosHTML::makeOption( '0', _TEAC_LANG_NO );
      	$yesno[] = mosHTML::makeOption( '1', _TEAC_LANG_YES );

		$configList=array();
		$configList['weekend'] = mosHTML::selectList( $yesno, 'cfg_weekend', 'class="inputbox" size="1"', 'value', 'text', $teacConfig['weekend'] );
		$configList['publichol'] = mosHTML::selectList( $yesno, 'cfg_publichol', 'class="inputbox" size="1"', 'value', 'text', $teacConfig['publichol'] );
		$configList['ownhol'] = mosHTML::selectList( $yesno, 'cfg_ownhol', 'class="inputbox" size="1"', 'value', 'text', $teacConfig['ownhol'] );
		$configList['prevmonth'] = mosHTML::selectList( $yesno, 'cfg_prevmonth', 'class="inputbox" size="1"', 'value', 'text', $teacConfig['prevmonth'] );
		$configList['nextmonth'] = mosHTML::selectList( $yesno, 'cfg_nextmonth', 'class="inputbox" size="1"', 'value', 'text', $teacConfig['nextmonth'] );
		$configList['showcopy'] = mosHTML::selectList( $yesno, 'cfg_showcopy','class="inputbox" size="1"', 'value', 'text', $teacConfig['showcopy']);		
                $configList['showcomment'] = mosHTML::selectList( $yesno, 'cfg_showcomment','class="inputbox" size="1"', 'value', 'text', $teacConfig['showcomment']);

		HTML_twTeac::showConfig( $option, $teacConfig, $configList );
	}
	function saveConfig ( $option ) {
		global $mosConfig_absolute_path;
   		// check if config file is writeable.
	   	$configfile = $mosConfig_absolute_path."/administrator/components/com_teac/teac_config.php";
   		if (!is_writable($configfile)) {
      		mosRedirect("index2.php?option=$option&task=editConfig", _TEAC_LANG_ERR_CONF_WRITE. ": ". $configfile);
   		}
   		$txt = "<?php\n";		 
		$txt .= "/*\n"
			."* Team Availability Component Configuration\n"
			."* @package TeamAvailabilityComponent\n"
			."* @copyright 2004 - 2005 Tom Winterhalder / 2006 Roland Furtmayr\n"
			."* @license http://www.gnu.org/copyleft/gpl.html. GNU Public License\n"
			."* @version $Revision: 1.3 $\n"
			."* @author Tom Winterhalder <tom@winterhalder.ch> Roland Furtmayr furtmayr@franken-connection.eu\n"
			."*/\n";
		$txt .= "/*\n"
			 . "* Description\n"
			 . "* ===========\n"
			 . "* This file contains the configuration of the Team availability Component\n"
			 . "* It is generated by the configuration interface of the component.\n"
			 . "* Don't make any modifications manually!\n"
			 . "*/\n";

   		foreach ($_POST as $k=>$v) {
      		if (strpos( $k, 'cfg_' ) === 0) {
         		if (!get_magic_quotes_gpc()) {
            		$v = addslashes( $v );
         		}
         		$txt .= "\$teacConfig['".substr( $k, 4 )."']='$v';\n";
      		}
   		}
   		$txt .= "?>";
   		if ($fp = fopen( $configfile, "w")) {
      		fputs($fp, $txt, strlen($txt));
      		fclose ($fp);
      		mosRedirect( "index2.php?option=$option&task=editConfig", _TEAC_LANG_CONF_SAVED );
   		} else {
      		mosRedirect( "index2.php?option=$option", _TEAC_LANG_ERR_CONF_OPEN );
   		}
	} // end function saveConfig
	// **********************
	// Abence control section
	// **********************
	// ------------------------------
	// publishes/unpublishes absences
	// ------------------------------
	function publishAbs( $option, $publish=1 ,$cid)
	{
		global $database, $my;

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$action = $publish ? 'publish' : 'unpublish';
			echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
			exit;
		}

		$cids = implode( ',', $cid );

		$database->setQuery( "UPDATE #__teac_absence SET published='$publish'"
			. "\nWHERE absid IN ($cids)"
		// AND (checked_out=0 OR (checked_out='$my->id')
		);
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		mosRedirect( "index2.php?option=$option&task=showAbsence" );
	}
	// -------------
	// save absences
	// -------------
	function saveAbs($option) {
		global $database;
		$row = new twTeacAbsence($database);

		// bind it to the table
		if (!$row -> bind($_POST)) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}

		// store it in the db
		if (!$row -> store()) {
			echo "<script> alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();	
		}
		mosRedirect("index2.php?option=$option&task=showAbsence", "Saved");
	}
	// ------------
	// edit absence
	// ------------
	function editAbs($option, $uid) {
		global $database;

		if($uid){
			$row = new twTeacAbsence($database);
			$row -> load($uid[0]);
		}
		HTML_twTeac::editAbs($option, $row);
	}
	// ---------------
	// deletes Absence
	// ---------------
	function delAbs($option, $cid) {
		global $database;
		if (!is_array($cid) || count($cid) < 1) {
			echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
			exit();
		}

		if (count($cid))
		{
			$ids = implode(',', $cid);
			$database->setQuery("DELETE FROM #__teac_absence \nWHERE absid IN ($ids)");
		}
		if (!$database->query()) {
			echo "<script> alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
		mosRedirect("index2.php?option=$option&task=showAbsence");
	}
	// -------------
	// list absences
	// -------------
	function listAbsence($option) {
		global $database, $limit, $limitstart;

		$query = "SELECT count(*) FROM #__teac_absence ";
		$database->setQuery( $query );
		$total = $database->loadResult();
		$pageNav = new mosPageNav( $total, $limitstart, $limit );

		$database->setQuery("SELECT * FROM #__teac_absence ORDER BY absid"
		. "\nLIMIT $pageNav->limitstart,$pageNav->limit" );

		$rows = $database -> loadObjectList();
		if ($database -> getErrorNum()) {
			echo $database -> stderr();
			return false;
		}
		HTML_twTeac::listAbsence($option, $rows, $pageNav);
	}


?>