<?php

	/*
	* Team Availabiliry 
	* @package TeamAvailabilityComponent frontend classes
	* @copyright 2004 Tom Winterhalder
	* @license http://www.gnu.org/copyleft/gpl.html. GNU Public License
	* @version $Revision: 1.8 $
	* @author Tom Winterhalder <tom@winterhalder.ch>
	*/
	/*
	* Description
	* ===========
	* Ich glaube hier wird der Kalender beschrieben
	*/
	//ensure this file is being included by a parent file
	defined('_VALID_MOS') or die ('Direct Access to this location is not allowed.');
	/*
	*  Class used for data interaction with the database
	*/
	class twTeacDB extends mosDBTable{
		var $teacid=null;
		var $user=null;
		var $unavfrom=null;
		var $unavto=null;
		var $abscode=null;
		var $comments=null;
		var $published=null;
		
		function twTeacDB(&$db) {
			global $database;
			$this->mosDBTable( '#__teac', 'teacid', $db );
		}
	}
	/*
	*  Class to handle the frontend of the component
	*/
	class twTeacFront {
		function showMonth($val){
			//echo $val;
			$months = array(
				1 => _TEAC_LANG_SJAN,
				2 => _TEAC_LANG_SFEB,
     			3 => _TEAC_LANG_SMAR,
     			4 => _TEAC_LANG_SAPR,
     			5 => _TEAC_LANG_SMAY,
     			6 => _TEAC_LANG_SJUN,
     			7 => _TEAC_LANG_SJUL,
     			8 => _TEAC_LANG_SAUG,
     			9 => _TEAC_LANG_SSEP,
     			10 => _TEAC_LANG_SOCT,
     			11 => _TEAC_LANG_SNOV,
     			12 => _TEAC_LANG_SDEC
   			);
   			return $months[$val];
		}
		/*
		*  Function to return the selectbox containing the year
		*/
 	   	function buildYearSelect($year,$args) {
			if (!$year){
	    	    $year=date("Y");
			}
			$y=date("Y");
			// Display 1 year in the past
       		if($year<$y-1){
            	$yearsList[] = mosHTML::makeOption( $year, $year );
        	}
			
        	for($i=$y-2;$i<=$y+3;$i++){                 	    				
            	$yearsList[] = mosHTML::makeOption( $i, $i );
	        }
			// Display 2 years in the future	
        	if($year>$y+2){
            	$yearslist[] = mosHTML::makeOption( $year, $year );
        	}
    	    $selectYear = mosHTML::selectList( $yearsList, 'year', $args, 'value', 'text', $year );
        	return $selectYear;
		} // end of function buildYearSelect
		/*
		*  builds a selectbox containing the available teams
		*/
		function buildTeamSelect($team,$args){
			global $database, $my, $teamList;
			$database->setQuery("Select * from #__gj_groups where active='1'");
			$teams=$database->loadObjectList();
			if (count($teams)>0){
				foreach($teams as $row)
				{	
					$teamList[] = mosHTML::makeOption( $row->name, $row->name);
				}
			}
			else {
				$teamList[] = mosHTML::makeOption(_TEAC_LANG_NO_TEAM, _TEAC_LANG_NO_TEAM);
			}
			$selectTeam = mosHTML::selectList( $teamList, 'team', $args, 'value', 'text', $team);
			return $selectTeam;
		} // end of function buildTeamSelect
		/*
		*  Checks for each day if it is a weekend or a public holiday
		*/
		function freeDay($day, $month, $year){
			/*
			*  day 0 is Sunday, day 6 is Saturday
			*  general public holidays in Switzerland are: 
			*  New Year, Berchtoldstag, Good Friday, Easter Monday, Auffahrt, 
			*  Pfingstmontag, Nationalfeiertag, Christmas day, Boxing day, Silvester
			*/
			global $teacConfig;
			// checks if day is on a weekend 
			$currDate=mktime(0,0,0,$month,$day,$year);
			if ($teacConfig['weekend']=='1') {
				if (date('w',$currDate)==0 || date('w',$currDate)==6) {
					//date('w',mktime(0,0,0,$month,$day,$year));
					return true;
				}
			}
			//new Year
			//$currDate=mktime(1,1,1,12,31,$year);
			$newYear=mktime(0,0,0,1,1,$year);
			//Berchtoldstag
			$Berchtoldstag=mktime(0,0,0,1,2,$year);
			//Easter
			$goodFriday=twTeacFront::easterdate($year)-60*60*24*2;
			$easterMonday=twTeacFront::easterdate($year)+60*60*24*2;
			$easterMonday=mktime(0,0,0,gmdate('m',$easterMonday),gmdate('d',$easterMonday),$year);
			//Ascension
			$ascension=twTeacFront::easterdate($year)+60*60*24*40;
			$ascension=mktime(0,0,0,gmdate('m',$ascension),gmdate('d',$ascension),$year);
			//Whitmonday
			$whitMonday=twTeacFront::easterdate($year)+60*60*24*51;
			$whitMonday=mktime(0,0,0,gmdate('m',$whitMonday),gmdate('d',$whitMonday),$year);	
			//National day
			$nationalDay=mktime(0,0,0,8,1,$year);
			//Christmas
			$christmas=mktime(0,0,0,12,25,$year);
			$boxingDay=mktime(0,0,0,12,26,$year);
			if ($teacConfig['publichol']=='1'){
				if ($currDate==$newYear || $currDate==$Berchtoldstag || $currDate==$goodFriday || $currDate==$easterMonday 
					|| $currDate==$ascension || $currDate==$nationalDay || $currDate==$whitMonday || $currDate==$christmas 
					|| $currDate==$boxingDay){
					return true;
				}
			}
			return false;	
		} // end of function freeDay
		/*
		*  Function to calculate the easterdate
		*/
  		function easterdate ($Year) {
  			/*
	       	G is the Golden Number-1
       		H is 23-Epact (modulo 30)
       		I is the number of days from 21 March to the Paschal full moon
       		J is the weekday for the Paschal full moon (0=Sunday,
         		1=Monday, etc.)
       		L is the number of days from 21 March to the Sunday on or before
         		the Paschal full moon (a number between -6 and 28)
       		*/

	        $G = $Year % 19;
			$C = (int)($Year / 100);
			$H = (int)($C - (int)($C / 4) - (int)((8*$C+13) / 25) + 19*$G + 15) % 30;
         	$I = (int)$H - (int)($H / 28)*(1 - (int)($H / 28)*(int)(29 / ($H + 1))*((int)(21 - $G) / 11));
         	$J = ($Year + (int)($Year/4) + $I + 2 - $C + (int)($C/4)) % 7;
         	$L = $I - $J;
         	$m = 3 + (int)(($L + 40) / 44);
         	$d = $L + 28 - 31 * ((int)($m / 4));
         	$y = $Year;
         	$E = mktime(0,0,0, $m, $d, $y);

         	return $E;

   		}  // end function easterdate
		/*
		*  Returns the current local date & time
		*/
		function getDate() {
			setlocale( LC_TIME, 'en-GB' );
			$now = time() + 3600; // Time is GMT + 1 hour (3600 seconds)
			if ( date( 'I' ) ) {
				$now += 3600; // Adjust for daylight saving time
			}
			return $now;
		}
		/*
		*  Returns the current month
		*/
		function getMonth(){
			$this->now=$this->getDate();
			$currMonth=gmdate('m',$now);
			return $currMonth;
		}
		/*
		*  Returns the current year
		*/
		function getYear(){
			$this->now=$this->getDate(); //$now=$this->getDate();
			$currDay=gmdate('Y',$now);
			return $currDay;
		}
		/*
		*  Creates a link using overlib
		*/
		function createOverlibLink($url, $row, $title){
		?>
			<a class="local<?php echo $row->abscode;?>" 
			href="<?php echo $url;?>" 
			onMouseOver="return overlib('<table border=0 width=100% height=100%><?php echo str_replace( "\r\n", '<br />', $row->comments );?></table>',CAPTION,'<?php echo $title;?>');" 
			onMouseOut="return nd()">
			<font color="<?php echo $row->absfontcol;?>"><?php echo $row->abscode;?></font>
			</a>
		<?
		}

	} // end of class twTeacFront
?>