<?php

	/*
	* Team Availabiliry 
	* @package TeamAvailabilityComponent frontend HTML
	* @copyright 2004 Tom Winterhalder
	* @license http://www.gnu.org/copyleft/gpl.html. GNU Public License
	* @version $Revision: 1.11 $
	* @author Tom Winterhalder <tom@winterhalder.ch>
	*/
	/*
	* Description
	* ===========
	* In this file the whole HTML part for the component is defined.
	*/
	//ensure this file is being included by a parent file
	defined('_VALID_MOS') or die ('Direct Access to this location is not allowed.');

	// includes the mos toolbar 
	require_once($GLOBALS['mosConfig_absolute_path'] . '/includes/HTML_toolbar.php');
	require_once ($mosConfig_absolute_path."/components/".$option."/teac.front.class.php");
	
	class HTML_teac{
		/*
		*  draw the table header
		*/
		function drawHeader(){
		?>
 			<link href="components/com_teac/css/teac.css" rel="stylesheet" type="text/css" />
			<table width="600">
				<tr>
					<td>
						<table width="100%" cellpadding="0" cellspacing="0" class="componentheading">
							<th><?php echo _TEAC_LANG_TITLE; ?> </th>
						</table>
					</td>
				</tr>
		<?php
		}

/*
*  draw date navigation bar with year and month select box.
*/
		function drawDateNavigation($option, $task, $Itemid, $month, $year, $team){
				?>
			<tr><td>
			<form name="teacNav" action="index.php" method="post" style="font-size:1;">
			<center><?php 
			// Build month select list
			echo mosHTML::monthSelectList('month','class="inputbox"',$month);
			// Build year select list
			echo twTeacFront::buildYearSelect($year,'class="inputbox"');
			echo "<input type=\"button\" name=\"refresh\" onClick=\"submit(this.form)\" value="._TEAC_LANG_REFRESH." />";
			echo "<br>";
			// Build team select list
			echo twTeacFront::buildTeamSelect($team,'class="inputbox" onchange="submit(this.form)"');
			?> </center>

				<input type="hidden" name="option" value="<?php echo $option; ?>" />
    				<input type="hidden" name="task" value="<?php echo $task; ?>" />
				<input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>" />
				<input type="hidden" name="userid" value="<?php echo $users; ?>" />
			</form>
			</td></tr>
			<tr>
		<?
		} // end of function drawDateNavigation

/*
*  Draws the calendar for the selected month and year with all absences  
*/
		function drawCalendar($option, $task, $users, $currMonth=NULL, $currYear=NULL, $team){
			global $mosConfig_live_site, $database, $is_editor, $is_manager, $teacConfig;
			// If month is not defined get the current month
			if (!$currMonth) {
				$currMonth=twTeacFront::getMonth();
			}
			// If year is not defined get the current year
			if (!$currYear){
				$currYear=twTeacFront::getYear();
			}
				// Select the absence codes
				$database->setQuery("select * from #__teac_absence where published='1'");
				$absence=$database->loadObjectList();
				// Build stylesheet for each absence code
				foreach ($absence as $row){
					echo "<style type=\"text/css\">";
					echo "<!--";
					echo "a.local".$row->abscode.":link, a.local".$row->abscode.":visited, a.local".$row->abscode.":hover{ ";
					echo "color: " .$row->absfontcol.";";
					echo "background: ".$row->absbgcol.";";
					echo "font-size: xx-small;";
					echo "text-decoration: none;";
					echo "vertical-align: center;";
					echo "padding-left: 0px;";
					echo "}";
					echo "-->";
					echo "</style>\n";
				}
			?>
			<tr><td><table class="teac" align="left">
			<?
			// Get number of days in the currently selected month
			$num = date("j",mktime(0,0,0,$currMonth+1,0,$currYear));
			echo "<tr><td width=\"*\"><b>".twTeacFront::showMonth(intval($currMonth))." ".$currYear."</b></td>\n";
			for($i=1; $i <= $num; $i++) {
				// day is weekend
				if (twTeacFront::freeDay($i, $currMonth, $currYear)){
					// Current user is editor, but not manager
					if ($is_editor && !$is_manager) {
						echo "<td width=\"12\" align=\"center\" bgcolor=".$teacConfig['freedaycolor'].">
							<a class=\"teacdate\" href=\"index.php?option=".$option."&task=edit\">".$i."</a></td>\n";
					}
					else 
						echo "<td width=\"12\" align=\"center\" bgcolor=".$teacConfig['freedaycolor'].">".$i."</td>\n";
				}
				else
					if ($is_editor && !$is_manager) {
						echo "<td width=\"12\" align=\"center\"><a class=\"teacdate\" href=\"index.php?option=".$option."&task=edit\">".$i."</a></td>\n";
					}
					else
						echo "<td width=\"12\" align=\"center\">".$i."</td>\n";
			} 
			echo "</tr>\n";

			foreach($users as $row) {

				HTML_teac::drawAvailability($option, $task, $currMonth, $currYear, $row);
			}
		?></table></td></tr><?
		} // end of function drawCalendar

/*
*  Draws the absences in the current month for all the users in the 
*  currently selected team
*/
		function drawAvailability($option, $task, $currMonth, $currYear, $user){
			global $database, $my, $is_manager, $is_editor, $team,$mosConfig_live_site,$teacConfig;



			$val=$user->groupid;

      

			// Get number of days in month
			$daysInMonth = date("j",mktime(0,0,0,$currMonth+1,0,$currYear));
			// Calculate the start and end time and date
			$startMonth= mktime(0,0,0,$currMonth,1,$currYear);
			$endMonth= mktime(0,0,0,$currMonth,$daysInMonth,$currYear);
			$startDate = date ( "Y-m-d 00:00:00", $startMonth );
			$endDate = date ( "Y-m-d 23:59:59", $endMonth );
			// select entries	
			$database->setQuery("select teacid, absid, unavfrom, unavto, t.abscode, a.abscode as abscode, absbgcol, absfontcol, comments \n"
				. "from #__teac t, #__teac_absence a \n"
				. "\nwhere t.abscode=absid and user='$val' and t.published='1' \n"
				. "order by unavfrom asc" );
			$entries=$database->loadObjectList();
			echo "<tr>\n";
			// compare the currently logged in user with the user in the database and check if the user is manager or not

			if (strcmp($my->username,$user->username)==0){
				echo "<td nowrap>
					<a class=\"teac\" href=\"index.php?option=$option&task=admin&user=$user->username\" >".$user->name."</a>
					</td>\n";
			}
			elseif ($is_manager)
				echo "<td nowrap><a class=\"teac\" href=\"index.php?option=$option&task=admin&user=$user->username\">".$user->name."</a></td>\n";
			else
				echo "<td nowrap>".$user->name."</td>\n";
			$entry=false;
			// Build calendar
			for($i=1; $i <= $daysInMonth; $i++) {
				$currDay= mktime(0,0,0,$currMonth,$i,$currYear);
				$currDate = date ( "Y-m-d 00:00:00", $currDay );
				$title="Absence comment";
				foreach ($entries as $row){

					if ((strtotime($currDate)>=strtotime($row->unavfrom)) && (strtotime($currDate)<=strtotime($row->unavto))){
						$entry=true;
						if (strcmp(strtolower($my->username),$user->username)==0 || $is_manager){
						?>
						<form action="index.php" method="post" name="adminForm">			
							<td bgcolor="<?php echo $row->absbgcol?>">
							<?
							if (($teacConfig['showcomment']==1) && (strlen($row->comments)>0)){
								if ($is_editor && !$is_manager)	{
									$url="index.php?option=".$option."&task=edit&myid=".$row->teacid;
									twTeacFront::createOverlibLink($url, $row, $title);
									echo "</td>";
								}
								else {
									$url="index.php?option=".$option."&task=edit&user=".$user->username."&myid=".$row->teacid;
									twTeacFront::createOverlibLink($url, $row, $title);
									echo "</td>";
								}
							}
							else {
								if ($is_editor && !$is_manager)
									echo "<a class=\"local".$row->abscode."\" href=\"index.php?option=".$option."&task=edit&myid=".$row->teacid."\">"
										. "<font color=$row->absfontcol>$row->abscode</font></a></td>";
								else
									echo "<a class=\"local".$row->abscode."\" href=\"index.php?option=$option&task=edit&user=$user->username&myid=".$row->teacid."\">"
										. "<font color=$row->absfontcol>$row->abscode</font></a></td>";
							}
							?>
							<input type="hidden" name="id" value="<?php echo $row->teacid ?>"/>
							<input type="hidden" name="unavfrom" value="<?php echo $row->unavfrom?>"/>
							<input type="hidden" name="unavto" value="<?php echo $row->unavto?>"/>
							<input type="hidden" name="option" value="<?php echo $option; ?>"/>
							<input type="hidden" name="task" value="task=admin&user=$user"/>
							<input type="hidden" name="user" value="<?php echo $user; ?>"/>
							<input type="hidden" name="boxchecked" value="0"/>
						</form>
						<?
						}
						else {
							if (($teacConfig['showcomment']==1) && (strlen($row->comments)>0)){
							?>
								<td width="12" align="center" bgcolor="<?php echo $row->absbgcol;?>">
							<?
								$url="javascript:void();";
								twTeacFront::createOverlibLink($url, $row, $title);
								echo "</td>";
							}
							else  {
							?>
								<td width="12" align="center" bgcolor="<?php echo $row->absbgcol;?>">
									<font color="<?php echo $row->absfontcol;?>"><?php echo $row->abscode;?></font>
								</td>
							<?
							}
						}
					}
				}
				if ($entry==false) {
					if (twTeacFront::freeDay($i, $currMonth, $currYear)){
						echo "<td width=\"12\" align=\"center\" bgcolor=".$teacConfig['freedaycolor'].">&nbsp;</td>\n";
					}
					else {
						echo "<td width=\"12\" align=\"center\">&nbsp;</td>\n";
					}		
				}
				$entry=false;
			}
			echo "</tr>";
		} // end function drawAvailability
		/*
		*  Draws a legend with all the absences and its absence code on the screen
		*/
		function drawLegend($option) {
			global $database, $is_editor, $team;
			$database->setQuery("select * from #__teac_absence where published='1'");
			$absence=$database->loadObjectList();
			?>
				<tr><td><table class="teaclegend" align="center" ><tr><td>
			<?
				foreach ($absence as $row){
					echo "<td class=\"teac\" nowrap bgcolor=".$row->absbgcol."><font color=$row->absfontcol><b>".$row->abscode."</td>
						<td class=\"teac\" nowrap> = ".$row->absdescr."</td><td>&nbsp;</td>\n";
				}
			?>
				</td></tr></table>
				</td></tr></table>
			<?
			if ($is_editor)
				echo "<p><a href=\"index.php?option=$option&task=admin&team=$team\" class=\"teac\">". _TEAC_LANG_MANAGE ."</a></p>\n";
		} // end function drawLegend
/*
*  Displays the copyright message
*/
		function drawCopyright(){
			global $teacConfig;
			if ($teacConfig['showcopy']==1) {
		    ?>	
    			<p align="center">
			    <a class="teac" href="http://www.winterhalder.ch" target="_blank" style=" font-size: xx-small;">Teac v<?php echo $teacConfig['version'];?></a>
				<font color="#999999" size="1">Copyright &copy; 2004-2005 by Tom Winterhalder</font>
			    </p> 
			<?php
			}
		} // end of function drawCopyright

/*
*  Displays a form to edit the selected entry with the necessary toolbar
*/
		function editEntry($option, $task, &$row, $absences, $user){
		?>
			<link href="components/com_teac/css/teac.css" rel="stylesheet" type="text/css" />
			<table class="teacnav"><tr><td>
		<?
			mosToolBar::startTable();
			mosToolBar::spacer(25);
			mosToolBar::save('saveEntry');
    	    mosToolBar::spacer(10);
			mosToolBar::cancel();
			echo "</td></tr>";
			echo "<tr><td></td><td width=\"50\" align=\"center\">save</td>
			<td></td>
			<td width=\"50\" align=\"center\">cancel</td></tr>";
			echo "</table>";
			mosToolBar::endtable();
		?>
			<script language="javascript" type="text/javascript" src="components/com_teac/js/datetimepicker.js"></script>
			<form action="index.php" method="post" id="adminForm" name="adminForm" class="adminForm">
			<table border="0" cellpadding="3" cellspacing="0">
			<tr>
			<td><? echo _TEAC_LANG_ABSCODE;?>:</td>
			<td><? echo mosHTML::selectList($absences,'abscode','size="1" class="inputbox"','value','text',$row->abscode); ?></td></tr>
			<tr><td><? echo _TEAC_LANG_UNAVFROM;?>:</td>
			<td><input type="text" readonly="true" id="unavfrom" name="unavfrom" maxlength="20" size="20" value="<?php echo $row->unavfrom; ?>"/>
			<a href="javascript:NewCal('unavfrom','yyyymmdd',false,24,'unavto')">
			<img src="components/com_teac/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"></a>
			</td></tr>
			<tr><td><? echo _TEAC_LANG_UNAVTO;?>:</td>
			<td><input type="text" readonly="true" id="unavto" name="unavto" maxlength="20" size="20" value="<?php echo $row->unavto; ?>"/>
			<a href="javascript:NewCal('unavto','yyyymmdd',false,24,'unavfrom')">
			<img src="components/com_teac/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"></a>
			</td></tr>
			<tr><td><?php echo _TEAC_LANG_COMMENTS;?></td>
			<td><textarea rows="5" cols="20" id="comments" name="comments"><?php echo $row->comments;?></textarea>
			</td>
			</tr>
			<tr><td><? echo _TEAC_LANG_PUBLISHED;?>:</td>
			<td><? echo mosHTML::yesnoSelectList("published","",1);?></td></tr>
			</table>
			<input type="hidden" name="user" value="<?php echo $user; ?>"/>
			<input type="hidden" name="teacid" value="<?php echo $row->teacid; ?>"/>
			<input type="hidden" name="option" value="<?php echo $option; ?>"/>
			<input type="hidden" name="task" value="admin"/>
			</form>
		<?
			HTML_Teac::drawCopyright();
		} // end of function editEntry

/*
*  Lists all the entries for the current user
*/
		function listEntries($option, $rows, $user, &$pageNav){
		?>
		<link href="components/com_teac/css/teac.css" rel="stylesheet" type="text/css" />
		<table class="teacnav"><tr><td>
		<?
		//	echo "<table border=\"1\" class=\"teac\" ><tr><td>";
			mosToolBar::startTable();
			mosToolBar::spacer(25);
			mosToolBar::publish('publish');
			mosToolBar::spacer(10);
			mosToolBar::unpublish('unpublish');
			mosToolBar::divider();
			mosToolBar::addNew('new');
			mosToolBar::spacer(10);
			mosToolBar::editList('edit','Edit');
			mosToolBar::spacer(10);
			mosToolBar::deleteList('','delete','Remove');
			echo "<tr><td></td><td width=\"55\" align=\"center\">"._TEAC_LANG_PUBLISH."</td>
				<td></td>
				<td width=\"55\" align=\"center\">"._TEAC_LANG_UNPUBLISH."</td>
				<td align=\"center\">&nbsp;</td>
				<td width=\"50\" align=\"center\">"._TEAC_LANG_NEW."</td>
				<td></td>
				<td width=\"50\" align=\"center\">"._TEAC_LANG_EDIT."</td>
				<td></td>
				<td width=\"50\" align=\"center\">"._TEAC_LANG_DELETE."</td></tr>";
			echo "</td></tr></table><br>";
			mosToolBar::endTable();
			?>
			<table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminlist">
			<!-- <tr><th colspan="5" align="center"><h3>Select Absence to edit</h3></th></tr> -->
			<form action="index.php" method="post" name="adminForm">
			<tr>
			<th width="20"><input type="checkbox" name="toggle" value="" onClick="checkAll(<?php echo count($rows);?>);"/></th>
			<th align="left"class="title"><? echo _TEAC_LANG_ABSENCE;?></th>
			<th align="left"><? echo _TEAC_LANG_UNAVFROM;?></th>
			<th align="left"><? echo _TEAC_LANG_UNAVTO;?></th>
			<th width="25%"><? echo _TEAC_LANG_PUBLISHED;?></th>
			</tr>
			<?php 
				$k=0;
				for ($i=0; $i < count($rows);$i++){
					$row=$rows[$i];
				?>
				<tr class="<?php echo "row$k"; ?>">
				<td width="20"><input type="checkbox" id="cb<?php echo $i;?>" name="cid[]" value="<?php echo $row->teacid; ?>" 
				onClick="isChecked(this.checked);"/></td>
				<td><a class="teac" href="#edit" onClick="return listItemTask('cb<?php echo $i;?>','edit')"><?php echo $row->absdescr;?></a></td>
				<td><?php echo $row->unavfrom;?></td>
				<td><?php echo $row->unavto;?></td>
				<td align="center" width="25%">
					<?php 
						if($row->published=="1"){
							echo "<a href=\"javascript: void(0);\" onClick=\"return listItemTask('cb$i', 'unpublish')\">
								  <img src=\"images/tick.png\" border=\"0\" /></a>";
						}
						else {
							echo "<a href=\"javascript: void(0);\" onClick=\"return listItemTask('cb$i', 'publish')\">
								  <img src=\"images/publish_x.png\" border=\"0\" /></a>";

						} ?> </td>
						<?php $k=1-$k; ?>
				</tr>
				<tr><td colspan="5">
				<?php }
					$link='index.php?option=com_teac&task=admin&user='.$user;
				    $html = '<table class="adminlist"><tr><th colspan="3">';
					$html .= $pageNav->writePagesLinks($link);
					$html .= '</th></tr><tr>';
					$html .= '<td nowrap="true" width="48%" align="right">'. _TEAC_LANG_DISPLAY.'</td>';
					$html .= '<td>' .$pageNav->getLimitBox($link) . '</td>';
					$html .= '<td nowrap="true" width="48%" align="left">' . $pageNav->writePagesCounter() . '</td>';
					$html .= '</tr></table>';
	  				echo $html;
				?>
				</td></tr>
				<input type="hidden" name="option" value="<?php echo $option; ?>"/>
				<input type="hidden" name="task" value="task=admin&user=$user"/>
				<input type="hidden" name="user" value="<?php echo $user; ?>"/>
				<input type="hidden" name="rows" value="<?php echo $rows; ?>"/>
				<input type="hidden" name="total" value="<?php echo $total; ?>"/>
				<input type="hidden" name="limit" value="<?php echo $limit; ?>"/>
				<input type="hidden" name="boxchecked" value="0"/>
			</form>
			<tr><td><a class="teac" href="index.php?option=com_teac"><?php echo _TEAC_LANG_BACK ?></a></td></tr>			
			</table>
		<?
		} // end of function listEntries

/*
*  Draws a list for the team administrator with all the teammembers to modify each member.
*/
		function drawAdminList($option, $rows){
			?>
			<table>
				<tr><td>Please select a user to modify his entries:</td></tr>
				<? 
					foreach ($rows as $row){
						echo "<tr><td><a class=\"teac\" href=\"index.php?option=$option&task=admin&user=$row->username\">". $row->member ."</a></td></tr>";
						//<tr><td><a href=""<? echo $row->member ." " .$row->manager; 
					}
			echo "<tr><td><a class=\"teac\" href=\"index.php?option=com_teac\">"._TEAC_LANG_BACK."</a></td></tr>";
			echo "</table>";
		} // end of function drawAdminList
	}
?>