<?php 

	/**
	* Team Availabiliry Component Frontend
	* @package TeamAvailabilityComponent event handler
	* @copyright 2004 Tom Winterhalder
	* @license http://www.gnu.org/copyleft/gpl.html. GNU Public License
	* @version $Revision: 1.11 $
	* @author Tom Winterhalder <tom@winterhalder.ch>
	*/
	/*
	* Description
	* ===========
	* This is the main event handler for the frontend of the component.
	*/

	//ensure this file is being included by a parent file
	defined('_VALID_MOS') or die ('Direct Access to this location is not allowed.');
	global $month, $year, $team, $mainframe, $teacConfig;
	require_once($mainframe->getPath('front_html'));
	require_once ($mosConfig_absolute_path."/components/".$option."/teac.front.class.php");

// CHECK LANGUAGE
	if (!defined( '_CAL_LANG_INCLUDED' )) {
    	if (file_exists("administrator/components/com_teac/language/".$mosConfig_lang.".php") ) { 
        	include_once("administrator/components/com_teac/language/".$mosConfig_lang.".php");
	    } else { 
    	    include_once("administrator/components/com_teac/language/english.php");
	    }
	}

// prepare page navigation
	require_once( $GLOBALS['mosConfig_absolute_path'] . '/includes/pageNavigation.php' );
	$limit = intval( mosGetParam( $_REQUEST, 'limit', '10' ) );
	$limitstart = intval( mosGetParam( $_REQUEST, 'limitstart', $limitstart ) );

//include configuration file
	if (file_exists($GLOBALS['mosConfig_absolute_path'].'/administrator/components/com_teac/teac_config.php')) {
	  include($GLOBALS['mosConfig_absolute_path'].'/administrator/components/com_teac/teac_config.php');
	} else {
	  die ("Error finding configuration file (".$GLOBALS['mosConfig_absolute_path']."/administrator/components/com_teac/teac_config.php)");
	}

// CHECK ACCESS
	$username=strtolower($my->username);
	$is_editor = 0;
	$is_manager = 0;

// selects the username and managername to be able to define if the user is teammember or manager
	$database->setQuery("SELECT distinct u.username as member , ma.username as manager"
			. "\nFROM #__gj_users m, #__users u, #__users ma"
			. "\nwhere u.id=m.id_user and ma.id=manager group by ma.username having member='$username' or manager='$username'"
			. "\n");
	$curruser=$database->loadObjectList();
	if (count($curruser)>0){

// Hier steht wer alles Editor ist
		$is_editor = (strtolower($my->usertype) == 'author' || strtolower($my->usertype) == 'publisher'
	    || strtolower($my->usertype) == 'editor' || strtolower($my->usertype) == 'administrator' 
    	|| strtolower($my->usertype) == 'super administrator' || strtolower($my->usertype) == 'registered')
		&& ( $curruser[0]->member==$username || $curruser[0]->manager==$username );
	}

// Hier steht wer alles Manager ist (eventuell registrierte Benutzer hinzufgen
	$is_manager = (($is_editor && $curruser[0]->manager==$username) || (strtolower($my->usertype) == 'administrator')
			 || (strtolower($my->usertype) == 'super administrator'));
	
	$id = mosGetParam( $_REQUEST, 'cid', array(0) );
	if (!is_array( $id )) {
		$id = array(0);
	}
		
	setlocale( LC_TIME, 'en-GB' );
	$now = time() + 3600; // Time is GMT + 1 hour (3600 seconds)
	if ( date( 'I' ) ) {
		$now += 3600; // Adjust for daylight saving time
	}
	
/*
*  Creates the calendar with the navigation bar.
*/
	function drawCalendar($option, $task, $Itemid, $month, $year, $team) {
		global $database, $now, $month, $year, $username, $is_editor, $team, $teacConfig, $mosConfig_live_site;
	?>
		<script language="Javascript" src="<?php echo $mosConfig_live_site;?>/includes/js/overlib_mini.js"></script>
		<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>
	<?

// If $team is not defined use first team. Also check if there are no team defined at all.
		if (strlen($team)==0&& $is_editor) {
			$database->setQuery("select name from #__users u, #__gj_groups g, #__gj_users m where"
				. "\nu.username='$username' and team=g.id and m.id_user=id and m.status='0' group by name");
			$teammember=$database->loadObjectList();
			if (count($teammember)<=0){
				$database->setQuery("select count(*) as counter, name from #__users, #__gj_groups g, #__gj_users m where"
					. "\nteam=g.id and m.id_user=id and m.status='0' group by name");
				$teammember=$database->loadObjectList();
			}
			$team=$teammember[0]->name;
		}
		elseif (strlen($team)==0){
			$database->setQuery("select name from #__gj_groups");
			$teammember=$database->loadObjectList();
			//check if there are teammembers available
			if (count($teammember)<=0) {
				$teammember[0]->name=_TEAC_LANG_NO_TEAM;
			}
			else
				$team=$teammember[0]->name;
		}
		if (!$month) {
			$month=gmdate('m',$now);
		}
		if (!$year) {
			$year=gmdate('Y', $now);
		}
		$database->setQuery("select id from #__gj_groups where name='$team'");
		$teams=$database->loadObjectList();
		//check if teams are defined
		if (count($teams)<=0){
			$val=_TEAC_LANG_NO_TEAM;
		}
		else
			$val= $teams[0]->id;

// Select informations about team members
		$database->setQuery("select m.id as groupid, m.id, m.id_user, m.id_group, m.status, u.id, u.name as name," 
			. "ma.id, ma.name as manager, u.username as username\n"
			. "from #__gj_users m, #__users u, #__users ma"
			. "\nwhere m.id_user=u.id and m.id_user=ma.id and m.id_group='$val' and m.status='0' order by m.id_user desc");
		$users = $database->loadObjectList();

// Select all the entered absences
		$database->setQuery("select * from #__teac where published='1'");
		$entries=$database->loadObjectList();

// Building the calendar
		HTML_teac::drawHeader();
		HTML_teac::drawDateNavigation($option, $task, $Itemid, $month, $year, $team);

// Check if previous month should be displayed and calculate previous month
		if ($teacConfig['prevmonth']=='1') {
			if ($month=='01'){
				$prevMonth = '12';
				$prevYear = $year-1;
			}
			else {
				$prevMonth = $month-1;
				$prevYear = $year;
			}
			HTML_teac::drawCalendar($option, $task, $users, $prevMonth, $prevYear, $team);
			echo "<tr><td>&nbsp;</td></tr>";
		}

// Display current month
		HTML_teac::drawCalendar($option, $task, $users, $month, $year, $team);

// Check if next month should be displayed and calculate next month
		if ($teacConfig['nextmonth']=='1') {
			if ($month=='12') {
				$nextMonth = '01';
				$nextYear = $year+1;
			}
			else {
				$nextMonth = $month+1;
				$nextYear = $year;
			}
			echo "<tr><td>&nbsp;</td></tr>";
			HTML_teac::drawCalendar($option, $task, $users, $nextMonth, $nextYear, $team);
		}
		HTML_teac::drawLegend($option);
		HTML_teac::drawCopyright();
	} // end of function drawCalendar

/*
*  Edits the selected entry
*/
	function editEntry($option, $task, $user, $tid){
		global $database, $username;
		if($tid){
			$row = new twTeacDB($database);
			$row -> load($tid[0]);
		}
		$database->setQuery("select absid as value, absdescr as text from #__teac_absence where published='1'");
		$absences=$database->loadObjectList();
		/*echo "<script> javascript:alert('user:".$user." username ".$username."')</script>;";*/
		if ($user){
			$database->setQuery("SELECT m.id as id FROM #__users u, #__gj_users m
				where m.id_user=u.id and u.username='$user'");
		}
		else {
			$database->setQuery("SELECT m.id as id FROM #__users u, #__gj_users m
				where m.id_user=u.id and u.username='$username'");
		}
		$user=$database->loadObjectList();
		HTML_teac::editEntry($option, $task, $row, $absences, $user[0]->id);
	}

/*
*  Lists all the entries for the current user.
*/
	function listEntries($option,$adminList,$user=NULL){
		global $database, $my, $username, $limit, $limitstart;
		if($adminList && (strcmp($user,$username)!=0)){
			HTML_teac::drawAdminList($option,$adminList,$user);
		}
		else {
			if ($user){
				$query = "select count(*) from #__teac t, #__users u, #__gj_users m 
					 where u.username='$user' and m.id_user=u.id and t.user=m.id";
				$database->setQuery( $query );
				$total = $database->loadResult();
				if ( $total <= $limit ) $limitstart = 0;
				$pageNav = new mosPageNav( $total, $limitstart, $limit );
//				echo "Limits: " . $limit ." ". $limitstart. "<br>";
//				echo "pagenav: " . $pageNav->limitstart ." ". $pageNav->limit;
				$database->setQuery("SELECT teacid, unavfrom, unavto, t.published, a.abscode as abscode, absdescr
					FROM #__teac t, #__users u, #__teac_absence a, #__gj_users m
					where u.id=m.id_user and t.user=m.id and t.abscode=absid and u.username='$user' order by unavfrom
					\n LIMIT ". $limitstart .", ". $limit);
			}
			else{
				$query = "select count(*) from #__teac t, #__users u, #__gj_users m 
					 where u.username='$username' and m.id_user=u.id and t.user=m.id";
				$database->setQuery( $query );
				$total = $database->loadResult();
				if ( $total <= $limit ) $limitstart = 0;
				$pageNav = new mosPageNav( $total, $limitstart, $limit );
//				echo $pageNav->limitstart . $pageNav->limit;
				$database->setQuery("SELECT teacid, unavfrom, unavto, t.published, a.abscode as abscode, absdescr"
					."\nFROM #__teac t, #__users u, #__teac_absence a, #__gj_users m"
					."\nwhere u.id=m.id_user and user=m.id and t.abscode=absid and u.username='$username' order by unavfrom"
					."\n LIMIT ". $limitstart .", ". $limit);
			}
			$entries = $database -> loadObjectList();
//			echo $limit . " " . $limitstart;
			if ($user){
				HTML_teac::listEntries($option, $entries, $user, $pageNav);
			}
			else {
				HTML_teac::listEntries($option, $entries, $username, $pageNav);
			}
		}
	}

/*
*  Saves the currently displayed entry
*/
	function saveEntry($option) {
		global $database;
		$row = new twTeacDB($database);
		// bind the post to the table
		if (!$row -> bind($_POST)) {
			echo "<script> javascript:alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();
		}
		// check if there is a duplicate entry for one of the days
		$database->setQuery("select * from #__teac where user='$row->user'");
		$dbdates=$database->loadObjectList();
		foreach ($dbdates as $dates){
			if ((((strtotime($row->unavfrom)<=strtotime($dates->unavfrom))&&(strtotime($row->unavto)>=strtotime($dates->unavfrom)))||
			   ((strtotime($row->unavfrom) >= strtotime($dates->unavfrom))&&(strtotime($row->unavfrom)<=strtotime($dates->unavto))) ||
			   ((strtotime($row->unavfrom) <= strtotime($dates->unavfrom))&&(strtotime($row->unavto)>=strtotime($dates->unavto)))) &&
			     ($dates->teacid!=$row->teacid))
			{
			   echo "<script> javascript:alert('" . _TEAC_LANG_ALERTDATE
			   		."$dates->unavfrom - $dates->unavto'); window.history.go(-2); </script>\n";
				exit();
			}
		}
		// store entry in the db
		if (!$row -> store()) {
			echo "<script> javascript:alert('"
				.$row -> getError()
				."'); window.history.go(-1); </script>\n";
			exit();	
		}
		$database->setQuery("select u.username as id_user from #__gj_users m, #__teac, #__users u where m.id='$row->user' and m.id_user=u.id");
		$uname=$database->loadObjectList();
		$uname=$uname[1]->id_user;
		mosRedirect("index.php?option=$option&task=admin&user=$uname", _TEAC_LANG_SAVED);
	}

/*
*  Publishes / unpublishes an entry
*/
	function publish( $option, $publish=1 ,$cid)
	{
		global $database, $my;

		if (!is_array( $cid ) || count( $cid ) < 1) {
			$action = $publish ? 'publish' : 'unpublish';
			echo "<script> javascript:alert('Select an item to $action'); window.history.go(-1);</script>\n";
			exit;
		}

		$cids = implode( ',', $cid );

		$database->setQuery( "UPDATE #__teac SET published='$publish'"
			. "\nWHERE teacid IN ($cids)");
		if (!$database->query()) {
			echo "<script> javascript:alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		mosRedirect( "index.php?option=$option&task=admin" );
	}

/*
*  Deletes an entry from the db
*/
	function del($option, $cid) {
		global $database;
		if (!is_array($cid) || count($cid) < 1) {
			echo "<script> javascript:alert('Select an item to delete'); window.history.go(-1);</script>\n";
			exit();
		}

		if (count($cid))
		{
			$ids = implode(',', $cid);
			$database->setQuery("DELETE FROM #__teac \nWHERE teacid IN ($ids)");
		}
		if (!$database->query()) {
			echo "<script> javascript:alert('"
				.$database -> getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}
		mosRedirect("index.php?option=$option&task=admin");
	}
	
/*
*  Main event handling part
*/
	switch ($task){
		case 'admin':
			global $user;
			$database->setQuery("SELECT u.name as member, m.id, u.username, ma.name as manager, t.name
								FROM jos_gj_users m, jos_gj_groups t, jos_users u, jos_users ma
								where m.id_group=t.id and t.active='1' and t.name='$team' 
								and m.id_user=u.id and m.id_user=ma.id and ma.username='$username' and m.status='0' ");
			$adminList=$database->loadObjectList();
			listEntries($option,$adminList,$user);
			HTML_Teac::drawCopyright();
			break;
		case 'new':
			$id='';
		case 'edit':
			global $myid, $user;
			if ($myid)
				$id[0]=$myid;
			editEntry($option, $task, $user, $id);
			break;
		case "saveEntry" :
			saveEntry($option);
			break;
		case "publish" :
			publish($option, '1', $id);
			break;
		case "unpublish" :
			publish($option, '0', $id);
			break;
		case "delete" :
			del($option, $id);
			break;
		default:
			drawCalendar($option, $task, $Itemid, $month, $year, $team);
			break;
	}
?>
